package Forms
{
   import Common.SoundManager;
   import flash.display.DisplayObject;
   import flash.display.MovieClip;
   import flash.display.SimpleButton;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.text.TextField;
   import flash.ui.Mouse;
   
   public class CluelessBaseForm extends BaseForm
   {
       
      
      public var Music:String = "";
      
      public var TutorialStartFrame:int = 1;
      
      protected var _bSkipTutorial:ButtonSkipTutorial = null;
      
      public var bChangeMusic:Boolean = true;
      
      protected var _mcTutorial:TutorialMovieClip = null;
      
      protected var _mouseeffect:BaseEffect;
      
      protected var _bTutorialWaitForUser:Boolean = false;
      
      protected var _mcMouseCursor:MovieClip;
      
      protected var _mcTutorialBlotter:MCBlotter = null;
      
      public function CluelessBaseForm()
      {
         _mcTutorialBlotter = null;
         _mcTutorial = null;
         _bTutorialWaitForUser = false;
         _bSkipTutorial = null;
         TutorialStartFrame = 1;
         bChangeMusic = true;
         Music = "";
         super();
         _mcMouseCursor = new MouseCursor();
         addChild(_mcMouseCursor);
         _mouseeffect = new MouseEffect();
         addChild(_mouseeffect);
         _mcMouseCursor.mouseEnabled = false;
         _mcMouseCursor.mouseChildren = false;
         Mouse.hide();
         addEventListener(MouseEvent.MOUSE_MOVE,onMouseMove,false,0,true);
         _mcMouseCursor.visible = false;
         if(this.totalFrames > 1)
         {
            throw new Error("BaseForm has timeline!!!");
         }
         this.tabChildren = false;
      }
      
      override public function onUnfocus() : void
      {
         super.onUnfocus();
         _mcMouseCursor.visible = false;
         clearTutorial();
      }
      
      protected function onMouseMove(param1:MouseEvent) : void
      {
         _mcMouseCursor.x = this.mouseX;
         _mcMouseCursor.y = this.mouseY;
      }
      
      protected function localize(param1:TextField, param2:String) : void
      {
         param1.mouseEnabled = false;
         param1.text = Localization.getString(param2);
      }
      
      public function addSkipButton() : SimpleButton
      {
         if(_bSkipTutorial == null)
         {
            _bSkipTutorial = new ButtonSkipTutorial();
            _bSkipTutorial.x = 120;
            _bSkipTutorial.y = 435;
            addChildAt(_bSkipTutorial,getChildIndex(_mcMouseCursor));
         }
         return _bSkipTutorial;
      }
      
      protected function exitForm() : void
      {
         onBack(new MouseEvent(""));
      }
      
      override public function onFocus() : void
      {
         super.onFocus();
         onMouseMove(new MouseEvent(""));
         _mcMouseCursor.visible = true;
         if(Music != "" && bChangeMusic)
         {
            Storage.getInstance().playBGM(Music);
         }
      }
      
      protected function playSound(param1:String) : void
      {
         SoundManager.getInstance().playSound(param1);
      }
      
      protected function onTutorialWaitForUser(param1:Event) : void
      {
         _bTutorialWaitForUser = true;
      }
      
      protected function onMouseClickButtonSound(param1:MouseEvent) : void
      {
         playSound("ButtonClickSound");
      }
      
      public function turnBlotterOff(param1:Event) : void
      {
         _mcTutorialBlotter.visible = false;
      }
      
      protected function onTutorialBlotterClicked(param1:MouseEvent) : void
      {
         if(!_bTutorialWaitForUser)
         {
            gotoNextTutorialFrame();
         }
      }
      
      protected function gotoNextTutorialFrame() : void
      {
         _bTutorialWaitForUser = false;
         if(_mcTutorial != null)
         {
            turnBlotterOn(new Event(""));
            if(_mcTutorial.currentFrame < _mcTutorial.totalFrames)
            {
               _mcTutorial.gotoAndStop(_mcTutorial.currentFrame + 1);
            }
            else
            {
               clearTutorial();
            }
            SoundManager.getInstance().playSound("TutorialPopupSound");
         }
      }
      
      public function turnBlotterOn(param1:Event) : void
      {
         _mcTutorialBlotter.visible = true;
      }
      
      public function hideMouseCursor() : void
      {
         _mcMouseCursor.visible = false;
      }
      
      protected function onMouseOverButtonSound(param1:MouseEvent) : void
      {
         playSound("ButtonMouseOverSound");
      }
      
      protected function clearTutorial() : void
      {
         if(_mcTutorial != null)
         {
            removeChild(_mcTutorial);
            _mcTutorial = null;
         }
         if(_mcTutorialBlotter != null)
         {
            removeChild(_mcTutorialBlotter);
            _mcTutorialBlotter = null;
         }
         if(_bSkipTutorial != null)
         {
            removeChild(_bSkipTutorial);
            _bSkipTutorial = null;
         }
      }
      
      protected function setTutorial(param1:TutorialMovieClip) : void
      {
         var _loc2_:int = 0;
         _bTutorialWaitForUser = false;
         _mcTutorial = param1;
         _mcTutorial.gotoAndStop(TutorialStartFrame);
         _loc2_ = getChildIndex(_mcMouseCursor);
         addChildAt(_mcTutorial,_loc2_);
         _mcTutorial.addEventListener("turnBlotterOn",turnBlotterOn,false,0,true);
         _mcTutorial.addEventListener("turnBlotterOff",turnBlotterOff,false,0,true);
         _mcTutorial.addEventListener(MouseEvent.CLICK,onTutorialBlotterClicked,false,0,true);
         _mcTutorial.addEventListener("tutorialWaitForUser",onTutorialWaitForUser,false,0,true);
         if(_mcTutorialBlotter == null)
         {
            _mcTutorialBlotter = new MCBlotter();
            _mcTutorialBlotter.addEventListener(MouseEvent.CLICK,onTutorialBlotterClicked,false,0,true);
            _mcTutorialBlotter.alpha = 0;
            addChildAt(_mcTutorialBlotter,getChildIndex(_mcMouseCursor));
            SoundManager.getInstance().playSound("TutorialPopupSound");
         }
      }
      
      protected function installMouseOverSound(param1:DisplayObject) : void
      {
         param1.addEventListener(MouseEvent.MOUSE_OVER,onMouseOverButtonSound,false,0,true);
         param1.addEventListener(MouseEvent.CLICK,onMouseClickButtonSound,false,0,true);
      }
   }
}
