package Forms
{
   import Common.SoundManager;
   import flash.display.Bitmap;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.events.TimerEvent;
   import flash.system.fscommand;
   import flash.text.TextField;
   import flash.utils.Timer;
   
   [Embed(source="/_assets/assets.swf", symbol="Forms.ComposeForm")]
   public class ComposeForm extends CluelessBaseForm
   {
       
      
      public var _tfSnapshot:TextField;
      
      public var _mcModels:MovieClip;
      
      protected var _iSnapshotCountdown:int = 0;
      
      public var _tfBack:TextField;
      
      public var _mcModelBackground:MovieClip;
      
      protected var _timer:Timer;
      
      public var _bSnapshot:ButtonRound;
      
      public var _bMenu:ButtonRound;
      
      protected var _dragcontroller:DragController;
      
      public var _tfHelp:TextField;
      
      public function ComposeForm()
      {
         _dragcontroller = new DragController();
         _iSnapshotCountdown = 0;
         _timer = new Timer(200,0);
         super();
         setBackButton(_bMenu);
         installMouseOverSound(_bMenu);
         _tfHelp.visible = false;
         _tfSnapshot.mouseEnabled = false;
         _tfBack.mouseEnabled = false;
         _bSnapshot.addEventListener(MouseEvent.CLICK,onCapture,false,0,true);
         _timer.addEventListener(TimerEvent.TIMER,onTimer,false,0,true);
         _timer.start();
         if(MainDocument.DEMO_VERSION)
         {
            _bSnapshot.visible = false;
            _bSnapshot.mouseEnabled = false;
            _tfSnapshot.visible = false;
         }
      }
      
      public function addModel(param1:Model) : void
      {
         _mcModels.addChild(param1);
         _dragcontroller.setDragable(param1);
      }
      
      public function setBackground(param1:Bitmap) : void
      {
         while(_mcModelBackground.numChildren > 0)
         {
            _mcModelBackground.removeChildAt(0);
         }
         _mcModelBackground.addChild(param1);
      }
      
      protected function onCapture(param1:MouseEvent) : void
      {
         _iSnapshotCountdown = 5;
      }
      
      protected function onTimer(param1:Event) : void
      {
         if(_iSnapshotCountdown > 0)
         {
            switch(_iSnapshotCountdown)
            {
               case 5:
                  setVisible(false);
                  break;
               case 4:
                  SoundManager.getInstance().playSound("TakePictureSound");
                  if(MainDocument.isSWFStudio())
                  {
                     fscommand("exec","startdir://fscommand/snapshot.exe");
                  }
                  else
                  {
                     fscommand("exec","snapshot.exe");
                  }
                  break;
               case 1:
                  setVisible(true);
            }
            --_iSnapshotCountdown;
         }
      }
      
      protected function setVisible(param1:Boolean) : void
      {
         _tfSnapshot.visible = param1;
         _tfBack.visible = param1;
         _bMenu.visible = param1;
         _bSnapshot.visible = param1;
         _tfHelp.visible = param1;
         _mcMouseCursor.visible = param1;
         _mouseeffect.visible = param1;
      }
      
      protected function onSnapshot(param1:MouseEvent) : void
      {
         SoundManager.getInstance().playSound("TakePictureSound");
         setFormPermanent(new SnapshotForm());
      }
   }
}
