package Forms
{
   import Common.ResourceManager;
   import Cutscene.CutsceneManager;
   import Cutscene.GameCutsceneResolve;
   import flash.display.Loader;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.text.TextField;
   
   [Embed(source="/_assets/assets.swf", symbol="Forms.CutsceneForm")]
   public class CutsceneForm extends CluelessBaseForm
   {
       
      
      public var txtSkip:TextField;
      
      private var loader:Loader;
      
      internal var cutsceneMgr:CutsceneManager;
      
      public var txtOwnerBack_mc:MovieClip;
      
      private var nextForm:BaseForm;
      
      public var _bSkipall:ButtonRound;
      
      public var txtDialogue:TextField;
      
      private var intro:int = 0;
      
      public var cutsceneImages:MovieClip;
      
      public var _bNext:ButtonRound;
      
      public var txtNext:TextField;
      
      public var txtSpeaker:TextField;
      
      public var _mcCutsceneTextBack:MovieClip;
      
      public var dialogbox_mc:MovieClip;
      
      public function CutsceneForm()
      {
         intro = 0;
         cutsceneMgr = CutsceneManager.getInstance();
         super();
         cutsceneMgr.setSceneParent(MovieClip(this));
         cutsceneMgr.CutsceneResolvePlugin = new GameCutsceneResolve();
         installMouseOverSound(_bSkipall);
         installMouseOverSound(_bNext);
         txtSkip.mouseEnabled = false;
         txtNext.mouseEnabled = false;
      }
      
      override public function onFocus() : void
      {
         super.onFocus();
         if(intro == 1)
         {
            onBack(new MouseEvent(""));
         }
         intro = 1;
      }
      
      public function stopUpdates() : *
      {
         removeEventListener(Event.ENTER_FRAME,onCutsceneEnterFrame);
         _bNext.removeEventListener(MouseEvent.MOUSE_DOWN,cutsceneMgr.onPressSkip);
         _bSkipall.removeEventListener(MouseEvent.MOUSE_DOWN,cutsceneMgr.skipScene);
         if(nextForm != null)
         {
            setFormPermanent(nextForm);
         }
         else
         {
            onBack(new MouseEvent(""));
         }
      }
      
      internal function onCutsceneEnterFrame(param1:Event) : *
      {
         if(cutsceneMgr.doneLoading())
         {
            cutsceneMgr.update();
         }
      }
      
      public function init(param1:BaseForm, param2:String) : void
      {
         nextForm = param1;
         cutsceneMgr.queueLoadCutscene(MainDocument.resManager.getResource(param2,ResourceManager.C_XML) as XML);
         cutsceneMgr.setCutsceneDisplayElements(txtSpeaker,txtDialogue,txtOwnerBack_mc,txtSkip,_bSkipall,_mcCutsceneTextBack,cutsceneImages);
         cutsceneMgr.LoadToSceneAfterLoading = true;
         addEventListener(Event.ENTER_FRAME,onCutsceneEnterFrame,false,0,true);
         _bNext.addEventListener(MouseEvent.MOUSE_DOWN,cutsceneMgr.onPressSkip,false,0,true);
         _bSkipall.addEventListener(MouseEvent.MOUSE_DOWN,cutsceneMgr.skipScene,false,0,true);
         cutsceneMgr.loadBackground();
         cutsceneMgr.loadCutscene();
      }
   }
}
