package Forms
{
   import caurina.transitions.Tweener;
   import flash.display.Loader;
   import flash.events.Event;
   import flash.events.IOErrorEvent;
   import flash.net.URLRequest;
   import flash.text.TextField;
   import flash.ui.Mouse;
   
   [Embed(source="/_assets/assets.swf", symbol="Forms.LoadingForm")]
   public class LoadingForm extends BaseForm
   {
       
      
      internal var bShowForm:Boolean = false;
      
      internal var bLogoShown:Boolean = false;
      
      internal var loader:Loader;
      
      public var _mcBlotter:MCBlotter;
      
      internal var tempBaseForm:BaseForm;
      
      internal var logoCount:int = 0;
      
      public var _mcLoadingBar:LoadingBar;
      
      public var _tfVersion:TextField;
      
      internal var request:URLRequest;
      
      public var bShowingLogos:Boolean = false;
      
      public function LoadingForm()
      {
         loader = new Loader();
         logoCount = 0;
         bLogoShown = false;
         bShowForm = false;
         bShowingLogos = false;
         super();
         Storage.getInstance().playBGM("");
         Mouse.hide();
         bShowingLogos = false;
      }
      
      internal function startFadeTween() : void
      {
         Tweener.addTween(loader,{
            "alpha":0,
            "time":2,
            "onComplete":LoadNextLogo
         });
      }
      
      internal function loadComplete(param1:Event) : void
      {
         loader.visible = true;
         loader.alpha = 0;
         addChild(loader);
         bLogoShown = true;
         Tweener.addTween(loader,{
            "alpha":1,
            "time":2,
            "onComplete":startStayTween
         });
      }
      
      public function switchForm(param1:BaseForm) : void
      {
         if(!bShowingLogos)
         {
            setFormPermanent(param1);
         }
         else
         {
            tempBaseForm = param1;
            bShowForm = true;
         }
      }
      
      internal function startStayTween() : void
      {
         Tweener.addTween(loader,{
            "alpha":1,
            "time":3,
            "onComplete":startFadeTween
         });
      }
      
      internal function LoadNextLogo() : void
      {
         if(bLogoShown)
         {
            removeChild(loader);
            bLogoShown = false;
         }
         if(logoCount == 1)
         {
            loadLogo("Res/Logos/Paramount_logo.jpg");
            ++logoCount;
         }
         else if(logoCount == 0)
         {
            loadLogo("Res/Logos/Partner.jpg");
            ++logoCount;
         }
         else if(logoCount == 3)
         {
            loadLogo("Res/Logos/LastLogo.jpg");
            ++logoCount;
         }
         else if(logoCount == 2)
         {
            loader.visible = false;
            ++logoCount;
         }
         else
         {
            loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR,handleIOError);
            loader.contentLoaderInfo.removeEventListener(Event.COMPLETE,loadComplete);
            _mcBlotter.visible = false;
            bShowingLogos = false;
            Storage.getInstance().playBGM("MenuMusic");
            if(bShowForm)
            {
               setFormPermanent(tempBaseForm);
            }
         }
      }
      
      internal function handleIOError(param1:IOErrorEvent) : void
      {
         LoadNextLogo();
      }
      
      public function setFraction(param1:Number) : void
      {
         _mcLoadingBar.setFraction(param1);
      }
      
      public function nextFLV(param1:Event) : void
      {
         LoadNextLogo();
      }
      
      internal function loadLogo(param1:String) : void
      {
         request = new URLRequest(param1);
         loader.load(request);
      }
      
      public function setLoadingText(param1:String) : void
      {
         _mcLoadingBar.setText(param1);
      }
   }
}
