package Forms
{
   import Common.SoundManager;
   import flash.display.SimpleButton;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.text.TextField;
   
   [Embed(source="/_assets/assets.swf", symbol="Forms.OptionsForm")]
   public class OptionsForm extends CluelessBaseForm
   {
       
      
      public var _bVoiceOvers:SimpleButton;
      
      public var _textFullscreen:TextField;
      
      internal const kOff:String = "O F F";
      
      public var _textBGM:TextField;
      
      public var _bParticleEffects:SimpleButton;
      
      public var _textVoiceOvers:TextField;
      
      public var _mcBGMVolume:TimerBarSmall;
      
      public var _mcSFXVolume:TimerBarSmall;
      
      public var _bBack:ButtonRound;
      
      internal const kOn:String = "O N";
      
      public var _tfUnlockAll:TextField;
      
      public var _bBGM:SimpleButton;
      
      public var _textParticleEffects:TextField;
      
      public var _bFullscreen:SimpleButton;
      
      public function OptionsForm()
      {
         super();
         Music = "MenuMusic";
         setBackButton(_bBack);
         _bFullscreen.addEventListener(MouseEvent.CLICK,onFullscreenChanged,false,0,true);
         _bBGM.addEventListener(MouseEvent.CLICK,onBGMChanged,false,0,true);
         _bVoiceOvers.addEventListener(MouseEvent.CLICK,onVoiceOversChanged,false,0,true);
         _bParticleEffects.addEventListener(MouseEvent.CLICK,onParticleEffectsChanged,false,0,true);
         _textBGM.text = toOnOff(Storage.getInstance().BGMEnabled);
         _textBGM.mouseEnabled = false;
         _textFullscreen.text = toOnOff(Storage.getInstance().FullscreenEnabled);
         _textFullscreen.mouseEnabled = false;
         _textVoiceOvers.text = toOnOff(Storage.getInstance().VoiceOvers);
         _textVoiceOvers.mouseEnabled = false;
         _textParticleEffects.text = toOnOff(Storage.getInstance().ParticleEffects);
         _textParticleEffects.mouseEnabled = false;
         _mcBGMVolume.addEventListener(MouseEvent.CLICK,onBGMVolumeClicked,false,0,true);
         _mcBGMVolume.addEventListener(MouseEvent.MOUSE_MOVE,onBGMVolumeMouseMove,false,0,true);
         _mcBGMVolume.setRatio(Storage.getInstance().BGMVolume);
         _mcSFXVolume.addEventListener(MouseEvent.CLICK,onSFXVolumeClicked,false,0,true);
         _mcSFXVolume.addEventListener(MouseEvent.MOUSE_MOVE,onSFXVolumeMouseMove,false,0,true);
         _mcSFXVolume.setRatio(Storage.getInstance().SFXVolume);
         _tfUnlockAll.addEventListener(MouseEvent.CLICK,onCheat,false,0,true);
         addEventListener(Event.ENTER_FRAME,onEnterFrame,false,0,true);
      }
      
      protected function onBGMChanged(param1:MouseEvent) : void
      {
         if(_textBGM.text == kOn)
         {
            _textBGM.text = kOff;
            Storage.getInstance().BGMEnabled = false;
         }
         else
         {
            _textBGM.text = kOn;
            Storage.getInstance().BGMEnabled = true;
         }
         Storage.getInstance().applyBGMState();
      }
      
      protected function onCheat(param1:MouseEvent) : void
      {
         Profile.Cheat = true;
      }
      
      protected function onParticleEffectsChanged(param1:MouseEvent) : void
      {
         if(_textParticleEffects.text == kOn)
         {
            _textParticleEffects.text = kOff;
            Storage.getInstance().ParticleEffects = false;
         }
         else
         {
            _textParticleEffects.text = kOn;
            Storage.getInstance().ParticleEffects = true;
         }
      }
      
      protected function onBGMVolumeMouseMove(param1:MouseEvent) : void
      {
         if(param1.buttonDown)
         {
            setBGMVolume(param1.localX);
         }
      }
      
      protected function onFullscreenChanged(param1:MouseEvent) : void
      {
         if(_textFullscreen.text == kOn)
         {
            _textFullscreen.text = kOff;
            Storage.getInstance().FullscreenEnabled = false;
         }
         else
         {
            _textFullscreen.text = kOn;
            Storage.getInstance().FullscreenEnabled = true;
         }
      }
      
      protected function onEnterFrame(param1:Event) : void
      {
         if(Storage.getInstance().FullscreenEnabled)
         {
            _textFullscreen.text = kOn;
         }
         else
         {
            _textFullscreen.text = kOff;
         }
      }
      
      protected function onSFXVolumeClicked(param1:MouseEvent) : void
      {
         setSFXVolume(param1.localX);
      }
      
      protected function onSFXVolumeMouseMove(param1:MouseEvent) : void
      {
         if(param1.buttonDown)
         {
            setSFXVolume(param1.localX);
         }
      }
      
      protected function toOnOff(param1:Boolean) : String
      {
         if(param1)
         {
            return kOn;
         }
         return kOff;
      }
      
      protected function setSFXVolume(param1:int) : void
      {
         var _loc2_:TimerBarSmall = null;
         var _loc3_:Number = NaN;
         var _loc4_:int = 0;
         _loc2_ = _mcSFXVolume;
         _loc3_ = param1;
         if(_loc3_ > _loc2_.width)
         {
            _loc3_ = _loc2_.width;
         }
         if(_loc3_ < 0)
         {
            _loc3_ = 0;
         }
         _loc4_ = _loc3_ * 11 / _loc2_.width;
         _loc2_.setRatio(_loc4_ / 10);
         Storage.getInstance().SFXVolume = _loc2_.getRatio();
         Storage.getInstance().applySFXState();
         SoundManager.getInstance().SFXVolume = Storage.getInstance().SFXVolume;
      }
      
      protected function setBGMVolume(param1:int) : void
      {
         var _loc2_:TimerBarSmall = null;
         var _loc3_:Number = NaN;
         var _loc4_:int = 0;
         _loc2_ = _mcBGMVolume;
         _loc3_ = param1;
         if(_loc3_ > _loc2_.width)
         {
            _loc3_ = _loc2_.width;
         }
         if(_loc3_ < 0)
         {
            _loc3_ = 0;
         }
         _loc4_ = _loc3_ * 11 / _loc2_.width;
         _loc2_.setRatio(_loc4_ / 10);
         Storage.getInstance().BGMVolume = _loc2_.getRatio();
         if(Storage.getInstance().BGMEnabled)
         {
            SoundManager.getInstance().BGVolume = Storage.getInstance().BGMVolume;
         }
      }
      
      protected function onVoiceOversChanged(param1:MouseEvent) : void
      {
         if(_textVoiceOvers.text == kOn)
         {
            _textVoiceOvers.text = kOff;
            Storage.getInstance().VoiceOvers = false;
         }
         else
         {
            _textVoiceOvers.text = kOn;
            Storage.getInstance().VoiceOvers = true;
         }
      }
      
      protected function onBGMVolumeClicked(param1:MouseEvent) : void
      {
         setBGMVolume(param1.localX);
      }
   }
}
