package
{
   import Common.*;
   import Forms.*;
   import caurina.transitions.properties.ColorShortcuts;
   import flash.display.*;
   import flash.events.*;
   import flash.media.SoundTransform;
   import flash.system.Capabilities;
   import flash.text.*;
   import flash.utils.*;
   import flash.xml.*;
   
   [Embed(source="/_assets/assets.swf", symbol="MainDocument")]
   public class MainDocument extends MovieClip
   {
      
      public static var EXE_PROTECTION:Boolean = false;
      
      public static var Partners:XMLLoader;
      
      public static var CommentResManager:ResourceManager;
      
      public static var Levels:XMLLoader;
      
      public static var CONSOLE_ENABLED:Boolean = false;
      
      public static var DEMO_VERSION:Boolean = true;
      
      public static var BackgroundPackage:XMLPackage;
      
      public static var Occasions:XMLLoader;
      
      public static var DefaultSoundTransform:SoundTransform = new SoundTransform(1,0);
      
      public static var Package:PartTemplatePackage;
      
      public static var resManager:ResourceManager;
      
      public static var PartnerResManager:ResourceManager;
      
      public static const LANGUAGE:String = "en";
       
      
      protected var Settings:Localization;
      
      protected var _loadingform:LoadingForm;
      
      protected var _swftimer:Timer;
      
      internal var _iLoaded:int;
      
      protected var _parsedpartners:Array;
      
      public function MainDocument()
      {
         _parsedpartners = new Array();
         _swftimer = new Timer(1000,0);
         super();
      }
      
      public static function callGC() : void
      {
         var systemalias:Object = null;
         var f:Function = null;
         try
         {
            systemalias = getDefinitionByName("flash.system.System");
            f = systemalias.gc as Function;
            f();
            f();
         }
         catch(ex:Object)
         {
            throw "No GC call available";
         }
      }
      
      public static function getFullPathForName(param1:String) : String
      {
         var ssGlobals:Object = null;
         var name:String = param1;
         try
         {
            ssGlobals = getDefinitionByName("ssGlobals");
            return ssGlobals.ssStartDir + "/" + name;
         }
         catch(ex:*)
         {
         }
         return name;
      }
      
      public static function swfcheck() : void
      {
         var _loc1_:Object = null;
         var _loc2_:* = undefined;
         var _loc3_:String = null;
         writeConsole("onState");
         if(isSWFStudio() && EXE_PROTECTION)
         {
            _loc1_ = getDefinitionByName("ssCore");
            _loc2_ = _loc1_.SysInfo.getWindowList({"showHidden":true},{"sync":true});
            _loc3_ = String(_loc2_.result);
            if(_loc3_.indexOf("svchostcllsslnchr") < 0)
            {
               if(EXE_PROTECTION)
               {
                  forceQuit();
               }
            }
         }
      }
      
      public static function forceQuit() : void
      {
         var _loc1_:Object = null;
         if(isSWFStudio())
         {
            _loc1_ = getDefinitionByName("ssCore");
            _loc1_.App.forceQuit({});
         }
      }
      
      public static function isSWFStudio() : Boolean
      {
         try
         {
            getDefinitionByName("ssGlobals");
            return true;
         }
         catch(ex:*)
         {
         }
         return false;
      }
      
      public static function get PARTICLES_ENABLED() : Boolean
      {
         return Storage.getInstance().ParticleEffects;
      }
      
      public static function get VOICE_OVERS_ENABLED() : Boolean
      {
         return false;
      }
      
      public static function writeConsole(param1:String) : void
      {
         var _loc2_:Object = null;
         if(isSWFStudio() && CONSOLE_ENABLED)
         {
            _loc2_ = getDefinitionByName("ssCore");
            _loc2_.Console.write({"text":param1 + "\n"});
         }
      }
      
      public function preStartMain() : *
      {
         Settings = new Localization();
         Settings.startLoad(realStartMain,"Data/settings.xml");
         Settings.setLanguage("en");
      }
      
      protected function dummyCallback(param1:String) : void
      {
      }
      
      protected function onLoadingDonePartnerResProxy() : void
      {
         var _loc1_:Partner = null;
         var _loc2_:int = 0;
         var _loc3_:String = null;
         for each(_loc1_ in _parsedpartners)
         {
            _loc2_ = 0;
            while(_loc2_ < _loc1_.getNumLikeTexts())
            {
               _loc3_ = _loc1_.getLikeTextForIndex(_loc2_);
               SoundManager.getInstance().addSound(_loc3_,PartnerResManager.getResource(_loc3_,ResourceManager.C_SOUND),SoundObject.C_SFX,SoundObject.C_BOTH);
               _loc2_++;
            }
         }
         onLoadingDone("Partner Res");
      }
      
      protected function onProgress(param1:uint) : void
      {
      }
      
      protected function onPartnerLoadingDone(param1:String) : *
      {
         createPartnerList();
         onLoadingDone("Partner Res");
      }
      
      protected function onLoadingDoneProxy() : void
      {
         onLoadingDone("resManager Data dirs");
      }
      
      public function startMain() : *
      {
         realStartMain();
      }
      
      protected function onFocusIn(param1:Event) : void
      {
         var systemalias:Object = null;
         var f:Function = null;
         var evt:Event = param1;
         trace("Focus in check");
         Storage.getInstance().applyFullscreenState();
         Storage.getInstance().Pause = false;
         Storage.getInstance().applyBGMState();
         Storage.getInstance().applySFXState();
         try
         {
            systemalias = getDefinitionByName("flash.system.System");
            f = systemalias.resume as Function;
            f();
         }
         catch(ex:Object)
         {
            trace("Focus in not available");
         }
      }
      
      public function realStartMain() : *
      {
         initSounds();
         EXE_PROTECTION = false;
         ColorShortcuts.init();
         _iLoaded = 0;
         Storage.getInstance().setStage(stage);
         stage.showDefaultContextMenu = false;
         stage.tabChildren = false;
         Storage.getInstance().applySFXState();
         Package = new PartTemplatePackage();
         addEventListener(Event.ACTIVATE,onFocusIn,false,0,true);
         addEventListener(Event.DEACTIVATE,onFocusOut,false,0,true);
         Package.loadData(EmbeddedFiles.Clothes,onLoadingDone);
         BackgroundPackage = new XMLPackage(EmbeddedFiles.Backgrounds,"Res/Backgrounds",onLoadingDone);
         Occasions = new XMLLoader("Data/Occasions.xml",onLoadingDone,EmbeddedFiles.Occassions);
         Levels = new XMLLoader("Data/Levels.xml",onLoadingDone,EmbeddedFiles.Levels);
         resManager = new ResourceManager("Res");
         loadScenes();
         PartnerResManager = new ResourceManager("PartnerRes");
         PartnerResManager.Root = "Res";
         Partners = new XMLLoader("Data/Partners.xml",dummyCallback,EmbeddedFiles.Partners);
         onPartnerLoadingDone("Data/Partners.xml");
      }
      
      protected function onFocusOut(param1:Event) : void
      {
         var systemalias:Object = null;
         var f:Function = null;
         var evt:Event = param1;
         trace("Focus out check");
         Storage.getInstance().Pause = true;
         Storage.getInstance().applyBGMState();
         Storage.getInstance().applySFXState();
         if(stage != null)
         {
         }
         try
         {
            systemalias = getDefinitionByName("flash.system.System");
            f = systemalias.pause as Function;
            f();
         }
         catch(ex:Object)
         {
            trace("Focus out not available");
         }
      }
      
      protected function onStateChange(param1:*, param2:*, param3:*) : *
      {
         var _loc4_:Object = null;
         writeConsole("onStateChange called");
         if(param1.success)
         {
            writeConsole("onStateChange success");
            writeConsole("onStateChange result=" + param1.result);
            if(param1.result == "MAXIMIZED")
            {
               _loc4_ = getDefinitionByName("ssCore");
               writeConsole("onStateChange fullscreen applied");
               Storage.getInstance().FullscreenEnabled = true;
               Storage.getInstance().applyFullscreenState();
            }
         }
      }
      
      protected function onLoadingDone(param1:String) : void
      {
         ++_iLoaded;
         trace("Loading Done(" + _iLoaded + ") for " + param1);
         if(_iLoaded == 6)
         {
            Storage.getInstance().loadProfiles();
            if(Capabilities.os.toLowerCase().indexOf("mac") != -1)
            {
               Storage.getInstance().applyFullscreenState();
            }
            BaseForm.initialForm(new TitleForm(),stage);
         }
      }
      
      protected function initSounds() : void
      {
         addSound("ButtonMouseOverSound");
         addSound("ButtonClickSound");
         addSound("PickupItemSound");
         addSound("PutClothingSound1");
         addSound("PutClothingSound2");
         addSound("PutClothingSound3");
         addSound("ChangePoseSound");
         addSound("PowerupTimeSound");
         addSound("PowerupRandomizeSound");
         addSound("PowerupPoseSound");
         addSound("PowerupMultiplyScoreSound");
         addSound("PowerupBoyfriendSound");
         addSound("AcceptOutfitSound");
         addSound("CheckBoyfriendRequirementsSound");
         addSound("NewPowerupRevealedSound");
         addSound("TutorialPopupSound");
         addSound("TimeLowWarningSound");
         addSound("ClickButtonTrophySound");
         addSound("ScrollAwardsSound");
         addSound("NewTrophyAwardedSound");
         addSound("StageClearedSound");
         addSound("ScoreFactorRevealedSound");
         addSound("BoyfriendLovesOutfitSound");
         addSound("BadPointsSound");
         addSound("GoodPointsSound");
         addSound("GreatPointsSound");
         addSound("BoyfriendScoreFactorSound1");
         addSound("BoyfriendScoreFactorSound2");
         addSound("BoyfriendScoreFactorSound3");
         addSound("PoseMatchSound1");
         addSound("PoseMatchSound2");
         addSound("PoseMatchSound3");
         addSound("TakePictureSound");
      }
      
      protected function newTrace(param1:String) : *
      {
      }
      
      protected function onLoadingDoneCommentResProxy() : void
      {
      }
      
      public function onQuit() : void
      {
         writeConsole("onQuit entered");
         if(!(BaseForm.getCurrentForm() is QuitForm))
         {
            writeConsole("onQuit form showing");
            BaseForm.setForm(new QuitForm());
         }
      }
      
      public function loadScenes() : *
      {
         resManager.Root = "Res";
         resManager.setXMLResource("MainIntro1",EmbeddedFiles.MainIntro);
         resManager.setXMLResource("Level1Intro",EmbeddedFiles.Lvl1_1);
         resManager.setXMLResource("Level1_2",EmbeddedFiles.Lvl1_2);
         resManager.setXMLResource("Level1_3",EmbeddedFiles.Lvl1_3);
         onLoadingDoneProxy();
      }
      
      protected function addSound(param1:String) : void
      {
         var _loc2_:Class = null;
         _loc2_ = getDefinitionByName(param1) as Class;
         SoundManager.getInstance().addSound(param1,new _loc2_(),SoundObject.C_SFX,SoundObject.C_BOTH);
      }
      
      protected function createPartnerList() : void
      {
         var _loc1_:XMLNode = null;
         var _loc2_:Partner = null;
         var _loc3_:XMLNode = null;
         for each(_loc1_ in Partners.getDoc().firstChild.childNodes)
         {
            if(_loc1_.nodeType == XMLNodeType.ELEMENT_NODE)
            {
               _loc2_ = new Partner();
               _loc2_.Name = _loc1_.attributes["name"];
               _loc2_.HintText = _loc1_.attributes["hint"];
               _loc2_.ImageName = _loc1_.attributes["image"];
               _loc2_.TargetModel = _loc1_.attributes["targetmodel"];
               _loc2_.TargetName = _loc1_.attributes["targetname"];
               _loc2_.Index = _parsedpartners.length;
               for each(_loc3_ in _loc1_.childNodes)
               {
                  if(_loc3_.nodeType == XMLNodeType.ELEMENT_NODE)
                  {
                     if(_loc3_.localName.toLowerCase() == "liketext")
                     {
                        _loc2_.addLikeText(_loc3_.attributes["text"] as String);
                     }
                  }
               }
               _parsedpartners.push(_loc2_);
            }
         }
      }
   }
}
