package
{
   import org.flintparticles.actions.Accelerate;
   import org.flintparticles.actions.Age;
   import org.flintparticles.actions.Fade;
   import org.flintparticles.actions.Move;
   import org.flintparticles.activities.FollowMouse;
   import org.flintparticles.counters.Steady;
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.initializers.ImageClasses;
   import org.flintparticles.initializers.Lifetime;
   import org.flintparticles.initializers.Velocity;
   import org.flintparticles.renderers.DisplayObjectRenderer;
   import org.flintparticles.zones.RectangleZone;
   
   public class MouseEffect extends BaseEffect
   {
       
      
      protected const PARTICLE_SPEED:int = 25;
      
      public function MouseEffect()
      {
         var _loc1_:DisplayObjectRenderer = null;
         super();
         this.mouseEnabled = false;
         _emitter = new Emitter();
         _emitter.counter = new Steady(5);
         _emitter.addInitializer(new ImageClasses([KintabLarge,KintabSmall]));
         _emitter.addActivity(new FollowMouse());
         _emitter.addInitializer(new Lifetime(0.1,6));
         _emitter.addAction(new Age());
         _emitter.addAction(new Fade());
         _emitter.addInitializer(new Velocity(new RectangleZone(-PARTICLE_SPEED,-PARTICLE_SPEED,0,0)));
         _emitter.addAction(new Accelerate(30,30));
         _emitter.addAction(new Move());
         while(numChildren > 0)
         {
            this.removeChildAt(0);
         }
         this.scaleX = 1;
         this.scaleY = 1;
         _loc1_ = new DisplayObjectRenderer();
         _emitter.renderer = _loc1_;
         addChild(_loc1_);
         if(this.name.indexOf("instance") != -1)
         {
            start();
         }
      }
      
      public function start() : void
      {
         _emitter.start();
         _emitter.runAhead(10);
      }
      
      public function get MainEmitter() : Emitter
      {
         return _emitter;
      }
   }
}
