package
{
   import Common.SoundManager;
   import Forms.DressupForm;
   import flash.display.*;
   import flash.events.Event;
   import flash.utils.*;
   import org.flintparticles.actions.*;
   import org.flintparticles.counters.*;
   import org.flintparticles.easing.*;
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.energyEasing.*;
   import org.flintparticles.initializers.*;
   import org.flintparticles.renderers.*;
   import org.flintparticles.zones.*;
   
   public class PowerupDoubleDamage extends Powerup
   {
       
      
      protected const NUM_PARTICLES:int = 100;
      
      internal var _dressupform:DressupForm;
      
      internal var _renderer:DisplayObjectRenderer;
      
      protected const PARTICLE_SPEED:int = 25;
      
      internal var _emitter:Emitter;
      
      protected const ZONE_WIDTH:int = 50;
      
      public var PartnerName:String = null;
      
      internal var _numAdded:int = 0;
      
      internal var _MCPartner:MCThumbnail;
      
      public function PowerupDoubleDamage()
      {
         _numAdded = 0;
         PartnerName = null;
         super();
         _sName = "double";
         _sDescription = "Doubles the value of the next match";
         _MCPartner = new MCThumbnail();
         _MCPartner.visible = false;
         _MCPartner.gotoAndStop(1);
         addEventListener(Event.ADDED_TO_STAGE,onAdded,false,0,true);
         addEventListener(Event.REMOVED_FROM_STAGE,onRemoved,false,0,true);
      }
      
      override public function init(param1:DressupLevelInfo) : void
      {
         var _loc2_:int = 0;
         super.init(param1);
         if(param1.getLevelPartners().length > 0)
         {
            _MCPartner.visible = true;
            this.alpha = 0;
            _loc2_ = int(Math.floor(Math.random() * param1.getLevelPartners().length));
            PartnerName = param1.getLevelPartners()[_loc2_].Name;
            trace(PartnerName);
            _MCPartner.gotoAndStop(PartnerName);
         }
      }
      
      protected function onMoved(param1:Event) : void
      {
         _MCPartner.x = this.x - _MCPartner.width / 2;
         _MCPartner.y = this.y - _MCPartner.height / 2;
      }
      
      protected function onAdded(param1:Event) : void
      {
         this.parent.addChildAt(_MCPartner,this.parent.getChildIndex(this));
         ++_numAdded;
         onMoved(param1);
      }
      
      override public function spawn() : Powerup
      {
         return new PowerupDoubleDamage();
      }
      
      protected function onRemoved(param1:Event) : void
      {
         if(_numAdded > 0)
         {
            this.parent.removeChild(_MCPartner);
            --_numAdded;
         }
      }
      
      protected function eraseEffect() : void
      {
      }
      
      override public function activate(param1:Array, param2:Array, param3:DressupForm, param4:DressupLevelInfo) : void
      {
         super.activate(param1,param2,param3,param4);
         SoundManager.getInstance().playSound("PowerupBoyfriendSound");
         param4.DoubleDamage = true;
         param4.DoubleDamageTarget = this.PartnerName;
         trace("Double damage if partner = " + PartnerName);
         setTimeout(eraseEffect,3000);
      }
   }
}
