package
{
   import Common.SoundManager;
   import Forms.DressupForm;
   import caurina.transitions.Tweener;
   import flash.display.MovieClip;
   import flash.geom.Point;
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.renderers.DisplayObjectRenderer;
   
   public class PowerupPoseLineup extends Powerup
   {
       
      
      protected const NUM_PARTICLES:int = 100;
      
      internal var _dressupform:DressupForm;
      
      internal var _renderer:DisplayObjectRenderer;
      
      protected const PARTICLE_SPEED:int = 25;
      
      internal var _emitter:Emitter;
      
      protected const ZONE_WIDTH:int = 50;
      
      public function PowerupPoseLineup()
      {
         super();
         _sName = "pose line";
         _sDescription = "Pose lineup bonus";
      }
      
      override public function spawn() : Powerup
      {
         return new PowerupPoseLineup();
      }
      
      protected function eraseEffect() : void
      {
         _emitter.pause();
         _dressupform.removeChild(_renderer);
         _emitter = null;
         _renderer = null;
      }
      
      override public function activate(param1:Array, param2:Array, param3:DressupForm, param4:DressupLevelInfo) : void
      {
         var _loc5_:MovieClip = null;
         var _loc6_:Point = null;
         super.activate(param1,param2,param3,param4);
         param4.LevelPoses = new Array();
         param4.LevelPoses.push(ModelPose.getRandomPose());
         param4.LevelPoses.push(ModelPose.getRandomPose());
         param4.LevelPoses.push(ModelPose.getRandomPose());
         param4.LevelPoseMultiplier = 0.5;
         param3.showPoseLineup();
         SoundManager.getInstance().playSound("PowerupPoseSound");
         _loc6_ = this.localToGlobal(new Point(this.x,this.y));
         for each(_loc5_ in [param3._mcPose0,param3._mcPose1,param3._mcPose2])
         {
            Tweener.addTween(_loc5_,{
               "x":_loc5_.x,
               "y":_loc5_.y,
               "time":0.2,
               "transition":"linear"
            });
            _loc5_.x = _loc6_.x;
            _loc5_.y = _loc6_.y;
         }
      }
   }
}
