package
{
   import flash.geom.Point;
   import org.flintparticles.actions.Age;
   import org.flintparticles.actions.DeathZone;
   import org.flintparticles.actions.Move;
   import org.flintparticles.counters.Steady;
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.initializers.ImageClasses;
   import org.flintparticles.initializers.Lifetime;
   import org.flintparticles.initializers.Position;
   import org.flintparticles.initializers.Velocity;
   import org.flintparticles.renderers.DisplayObjectRenderer;
   import org.flintparticles.zones.LineZone;
   import org.flintparticles.zones.RectangleZone;
   
   [Embed(source="/_assets/assets.swf", symbol="SparkleEffect")]
   public class SparkleEffect extends BaseEffect
   {
       
      
      public function SparkleEffect()
      {
         var _loc1_:DisplayObjectRenderer = null;
         super();
         _emitter = new Emitter();
         _emitter.counter = new Steady(10);
         _emitter.addInitializer(new ImageClasses([KintabLarge,KintabSmall]));
         _emitter.addInitializer(new Position(new RectangleZone(0,0,width,height)));
         _emitter.addInitializer(new Lifetime(1,2));
         _emitter.addAction(new Age());
         _emitter.addInitializer(new Velocity(new LineZone(new Point(0,5),new Point(0,50))));
         _emitter.addAction(new Move());
         _emitter.addAction(new DeathZone(new RectangleZone(0,0,width,height),true));
         while(numChildren > 0)
         {
            this.removeChildAt(0);
         }
         this.scaleX = 1;
         this.scaleY = 1;
         _loc1_ = new DisplayObjectRenderer();
         _emitter.renderer = _loc1_;
         addChild(_loc1_);
         if(this.name.indexOf("instance") != -1)
         {
            start();
         }
      }
      
      public function start() : void
      {
         if(MainDocument.PARTICLES_ENABLED)
         {
            _emitter.start();
            _emitter.runAhead(10);
         }
      }
      
      public function get MainEmitter() : Emitter
      {
         return _emitter;
      }
   }
}
