package org.flintparticles.initializers
{
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.particles.Particle;
   
   public class Lifetime extends Initializer
   {
       
      
      private var _max:Number;
      
      private var _min:Number;
      
      public function Lifetime(param1:Number, param2:Number = NaN)
      {
         super();
         _max = param2;
         _min = param1;
      }
      
      public function set maxLifetime(param1:Number) : void
      {
         _max = param1;
      }
      
      public function get maxLifetime() : Number
      {
         return _max;
      }
      
      override public function initialize(param1:Emitter, param2:Particle) : void
      {
         if(isNaN(_max))
         {
            param2.lifetime = _min;
         }
         else
         {
            param2.lifetime = _min + Math.random() * (_max - _min);
         }
      }
      
      public function set lifetime(param1:Number) : void
      {
         _max = _min = param1;
      }
      
      public function get lifetime() : Number
      {
         return _min == _max ? _min : (_max + _min) * 0.5;
      }
      
      public function get minLifetime() : Number
      {
         return _min;
      }
      
      public function set minLifetime(param1:Number) : void
      {
         _min = param1;
      }
   }
}
