package org.flintparticles.initializers
{
   import flash.geom.Point;
   import org.flintparticles.emitters.Emitter;
   import org.flintparticles.particles.Particle;
   import org.flintparticles.zones.Zone;
   
   public class Position extends Initializer
   {
       
      
      private var _zone:Zone;
      
      public function Position(param1:Zone)
      {
         super();
         _zone = param1;
      }
      
      public function get zone() : Zone
      {
         return _zone;
      }
      
      override public function initialize(param1:Emitter, param2:Particle) : void
      {
         var _loc3_:Point = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         if(param1.rotRadians == 0)
         {
            _loc3_ = _zone.getLocation();
            param2.x = _loc3_.x;
            param2.y = _loc3_.y;
         }
         else
         {
            _loc4_ = Math.sin(param1.rotRadians);
            _loc5_ = Math.cos(param1.rotRadians);
            _loc3_ = _zone.getLocation();
            param2.x = _loc5_ * _loc3_.x - _loc4_ * _loc3_.y;
            param2.y = _loc5_ * _loc3_.y + _loc4_ * _loc3_.x;
         }
         param2.x += param1.x;
         param2.y += param1.y;
      }
      
      public function set zone(param1:Zone) : void
      {
         _zone = param1;
      }
   }
}
